unit MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls,
  SeatFrame;

type
  TSeatInfo = record
    X, Y: Integer;
  end;
  TForm1 = class(TForm)
    Button1: TButton;
    edtSeatCount: TEdit;
    Button2: TButton;
    pnlSeatContainer: TPanel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
    FSeatInfos: array of TSeatInfo;

    FSeatList: array of TPanel;
    FSeatListFrame: array of TfrSeat;

    function CreateSeat(AName: string; AX, AY: Integer): TPanel;
    procedure ClearSeats;

    function CreateSeatFrame(AName, ATitle: string; AX, AY: Integer): TfrSeat;
    procedure ClearSeatsFrame;

    procedure SeatClick(Sender: TObject);
    procedure SeatFrameClick(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

const
  SEAT_WIDTH = 120;
  SEAT_HEIGHT = 150;
  SEAT_PADDING = 10;

procedure TForm1.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  SetLength(FSeatInfos, 10);

  for I := 0 to 9 do
  begin
    FSeatInfos[I].X := (I mod 5) * (SEAT_WIDTH + SEAT_PADDING) + SEAT_PADDING;
    FSeatInfos[I].Y := (I div 5) * (Seat_HEIGHT + SEAT_PADDING) + SEAT_PADDING;
  end;

//  FSeatInfos[0].X := 10;
//  FSeatInfos[0].Y := 10;
//  FSeatInfos[1].X := 120;
//  FSeatInfos[1].Y := 10;
//  FSeatInfos[2].X := 230;
//  FSeatInfos[2].Y := 10;
//  FSeatInfos[3].X := 340;
//  FSeatInfos[3].Y := 10;
//  FSeatInfos[4].X := 450;
//  FSeatInfos[4].Y := 10;
//
//  FSeatInfos[5].X := 10;
//  FSeatInfos[5].Y := 120;
//  FSeatInfos[6].X := 120;
//  FSeatInfos[6].Y := 120;
//  FSeatInfos[7].X := 230;
//  FSeatInfos[7].Y := 120;
//  FSeatInfos[8].X := 340;
//  FSeatInfos[8].Y := 120;
//  FSeatInfos[9].X := 450;
//  FSeatInfos[9].Y := 120;
end;

procedure TForm1.SeatClick(Sender: TObject);
begin
  ShowMessage(TPanel(Sender).Caption);
end;

procedure TForm1.SeatFrameClick(Sender: TObject);
begin
  ShowMessage(TfrSeat(Sender).Title);
end;

function TForm1.CreateSeat(AName: string; AX, AY: Integer): TPanel;
begin
  Result := TPanel.Create(Self);
  Result.Name := AName;
  Result.Width := SEAT_WIDTH;
  Result.Height := SEAT_HEIGHT;
  Result.Left := AX;
  Result.Top := AY;
  Result.Parent := pnlSeatContainer;

  Result.OnClick := SeatClick;
  Result.Visible := True;
end;

function TForm1.CreateSeatFrame(AName, ATitle: string; AX, AY: Integer): TfrSeat;
begin
  Result := TfrSeat.Create(Self);
  Result.Name := AName;
  Result.Width := SEAT_WIDTH;
  Result.Height := SEAT_HEIGHT;
  Result.Left := AX;
  Result.Top := AY;
  Result.Parent := pnlSeatContainer;

  Result.Title := ATitle;
  Result.OnClick := SeatFrameClick;

  Result.Visible := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ClearSeats;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ClearSeatsFrame;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  Seat: TfrSeat;
begin
  Seat := FSeatListFrame[5-1];
  if not Assigned(Seat) then
  begin
    ShowMessage('5ڸ ');
    Exit;
  end;

  Seat.AddMenu(Edit1.Text);
//  Seat.mmoMenus.Lines.Add(Edit1.Text);
end;

procedure TForm1.ClearSeats;
var
  Seat: TPanel;
begin
  for Seat in FSeatList do
    Seat.Free;
end;

procedure TForm1.ClearSeatsFrame;
var
  Seat: TfrSeat;
begin
  for Seat in FSeatListFrame do
    Seat.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I, Count: Integer;
  Seat: TPanel;
begin
  Count := StrToIntDef(edtSeatCount.Text, 10);
  if Count > 10 then
  begin
    ShowMessage('Max count is 10');
    Count := 10;
    edtSeatCount.Text := '10';
  end;


  SetLength(FSeatList, Count);
  for I := 0 to Count - 1 do
  begin
    Seat := CreateSeat('Seat' + I.ToString, FSeatInfos[I].X, FSeatInfos[I].Y);
    FSeatList[I] := Seat;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  I, Count: Integer;
  Seat: TfrSeat;
begin
  Count := StrToIntDef(edtSeatCount.Text, 10);
  if Count > 10 then
  begin
    ShowMessage('Max count is 10');
    Count := 10;
    edtSeatCount.Text := '10';
  end;


  SetLength(FSeatListFrame, Count);
  for I := 0 to Count - 1 do
  begin
    Seat := CreateSeatFrame('SeatFrame' + I.ToString, 'ڸ' + (I+1).ToString, FSeatInfos[I].X, FSeatInfos[I].Y);
    FSeatListFrame[I] := Seat;
  end;
end;

end.
