unit SeatFrame;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TfrSeat = class(TFrame)
    pnlHeader: TPanel;
    pnlContent: TPanel;
    Label1: TLabel;
    mmoMenus: TMemo;
    procedure mmoMenusClick(Sender: TObject);
    procedure pnlHeaderClick(Sender: TObject);
  private
    FMenus: TStrings;
    FTitle: string;
    procedure SetMenus(const Value: TStrings);
    procedure SetTitle(const Value: string);

    procedure DoClick;
    { Private declarations }
  public
    { Public declarations }
    property Title: string read FTitle write SetTitle;
    property Menus: TStrings read FMenus write SetMenus;

    procedure AddMenu(AMenu: string);
    procedure ClearMenu;
  end;

implementation

{$R *.dfm}

{ TFrame1 }

procedure TfrSeat.AddMenu(AMenu: string);
begin
  mmoMenus.Lines.Add(AMenu);
end;

procedure TfrSeat.ClearMenu;
begin
  mmoMenus.Clear;
end;

procedure TfrSeat.DoClick;
begin
  if Assigned(OnClick) then
    OnClick(Self);
end;

procedure TfrSeat.mmoMenusClick(Sender: TObject);
begin
  DoClick;
end;

procedure TfrSeat.pnlHeaderClick(Sender: TObject);
begin
  DoClick;
end;

procedure TfrSeat.SetMenus(const Value: TStrings);
begin
  FMenus := Value;

  mmoMenus.Lines.Assign(Value);
end;

procedure TfrSeat.SetTitle(const Value: string);
begin
  FTitle := Value;

  pnlHeader.Caption := Value;
end;

end.
